#include <stdio.h>
#include <stdlib.h>

#define MAX_LEVEL 	100
#define MAX_STACK	1000
#define	BASE	  display[level]

#define CTR_OFFS  0
#define RET_OFFS  1
#define SBP_OFFS  2
#define LEV_OFFS  3
#define PAR_OFFS  4		

#include "tipi.h"


num_type 	stack[MAX_STACK];	

int		ctr_link;
int		top_sp;			/* top stack pointer 	*/
int 		pc;			/* program counter 	*/
operandi 	op1,op2,op3;
int		param_count;		/* contatore parametri  */
int		level;			/* livello corrente 	*/
char 		stringa[20];
int		display[MAX_LEVEL];
int 		ival1,ival2,ival3;
double		rval1,rval2,rval3;

/*
num_type  val( operandi opx)
{
if (opx.ind.level==NOLEVEL)
	return opx.imm;
else return stack[display[opx.ind.level]+opx.ind.offset];
}
*/
#define   val(opx)  (  (opx.ind.level==NOLEVEL)? opx.imm : stack[display[opx.ind.level]+opx.ind.offset+PROC_HEADER] )
#define   mem(opx)     (stack[display[opx.ind.level]+opx.ind.offset+PROC_HEADER]) 

void run_quad()
{
op1=quadvect[pc].op1;
op2=quadvect[pc].op2;
op3=quadvect[pc].op3;
				
switch( quadvect[pc++].opcode )		/* le GOTO, le CALL e le RETURN reimposteranno correttamente pc	*/
   { 
      case IASSIGN : 	
      case RASSIGN : 	val(op2) = val(op1);
			break;

      case IADD    : 	ival1	 = val(op1).intero;
			ival2	 = val(op2).intero;
			mem(op3).intero = ival1 + ival2;
			break;
  
      case RADD    : 	rval1	 = val(op1).reale;
			rval2	 = val(op2).reale;
			mem(op3).reale = rval1 + rval2;
			break;  

      case ISUB    : 	ival1	 = val(op1).intero;
			ival2	 = val(op2).intero;
			mem(op3).intero = ival1 - ival2;
			break;
  
      case RSUB    : 	rval1	 = val(op1).reale;
			rval2	 = val(op2).reale;
			mem(op3).reale = rval1 - rval2;
			break; 

      case IMUL    : 	ival1	 = val(op1).intero;
			ival2	 = val(op2).intero;
			mem(op3).intero = ival1 * ival2;
			break; 

      case RMUL    : 	rval1	 = val(op1).reale;
			rval2	 = val(op2).reale;
			mem(op3).reale = rval1 * rval2;
			break; 

      case IDIV    : 	ival1	 = val(op1).intero;
			ival2	 = val(op2).intero;
			mem(op3).intero = ival1 / ival2;
			break; 

      case RDIV	   : 	rval1	 = val(op1).reale;
			rval2	 = val(op2).reale;
			mem(op3).reale = rval1 / rval2;
			break;

      case MOD     : 	ival1	 = val(op1).intero;
			ival2	 = val(op2).intero;
			mem(op3).intero = ival1 % ival2;
			break;

      case IUMIN   : 	mem(op2).intero=-val(op1).intero;
			break;

      case RUMIN   : 	mem(op2).reale=-val(op1).reale;
			break;

      case ITOR    :    mem(op2).reale=(double)val(op1).intero;
			break;

      case IGTR    :    if (val(op1).intero > val(op2).intero)
			  pc=op3.imm.intero; 
			break;

      case RGTR    :    if (val(op1).reale > val(op2).reale)
			  pc=op3.imm.intero; 
			break;

      case IGEQ    : if (val(op1).intero >= val(op2).intero)
			  pc=op3.imm.intero; 
			break;

      case RGEQ    : if (val(op1).reale >= val(op2).reale)
			  pc=op3.imm.intero; 
			break;

      case ILSS    : if (val(op1).intero < val(op2).intero)
			  pc=op3.imm.intero; 
			break;

      case RLSS    : if (val(op1).reale < val(op2).reale)
			  pc=op3.imm.intero; 
			break;

      case ILEQ    : if (val(op1).intero <= val(op2).intero)
			  pc=op3.imm.intero; 
			break;

      case RLEQ    : if (val(op1).reale <= val(op2).reale)
			  pc=op3.imm.intero; 
			break;

      case IEQ     : if (val(op1).intero == val(op2).intero)
			  pc=op3.imm.intero; 
			break;

      case REQ     : if (val(op1).reale == val(op2).reale)
			  pc=op3.imm.intero; 
			break;

      case INEQ    : if (val(op1).intero != val(op2).intero)
			  pc=op3.imm.intero; 
			break;

      case RNEQ    : if (val(op1).reale != val(op2).reale)
			  pc=op3.imm.intero; 
			break;

      case WRITEI  : 	printf("%d\n",val(op1)); 
      			if(trace_flag)
      				fprintf(file_output,"%d\n",val(op1)); 
      			break;
      			
      case WRITER  :	printf("%e\n",val(op1)); 
      			if(trace_flag)
      				fprintf(file_output,"%e\n",val(op1)); 
      			break;
      
      case READI   : 	printf("inserire numero intero:");
                       	scanf("%d",&stack[display[op1.ind.level]+op1.ind.offset+PROC_HEADER].intero);
      			break;
      			
      case READR   :  	printf("inserire numero reale:");
                       	scanf("%s",stringa);
		        stack[display[op1.ind.level]+op1.ind.offset+PROC_HEADER].reale = atof(stringa);			
      			break;
      			
      case IPARAM  :	stack[top_sp+LEV_OFFS+param_count++]=val(op1);
      			break;
      			
      case RPARAM  :	stack[top_sp+LEV_OFFS+param_count++]=val(op1);
      			break;
       			       
      case GOTO    : 	pc=op1.imm.intero;
       			break;
       			
      case CALL    :	stack[top_sp+CTR_OFFS].intero = BASE;	/* salvo nel control link il base pointer del chiamante */
      			stack[top_sp+RET_OFFS].intero = pc;	/* salvo il return address 		*/
      			level = stack[top_sp+LEV_OFFS].intero;	/* imposto il livello corrente  	*/
      			stack[top_sp+SBP_OFFS].intero = BASE;   /* salvo il vecchio valore del display 	*/
      			BASE=top_sp;				/* imposto il display		       	*/	
      			pc=op1.imm.intero;
       			break;
                     
      case RETURN  :	pc=stack[BASE+RET_OFFS].intero;		/* salto al Retun Address		*/
      			top_sp-=op1.imm.intero;  		/* pop del Record di Attivazione	*/
      			BASE=stack[top_sp+SBP_OFFS].intero;     /* ripristino il display col saved BP	*/
      			level=stack[stack[top_sp+CTR_OFFS].intero+LEV_OFFS].intero; /* pesco il level dal control link */
      			break;
                      
      case ALLOC   :	param_count=0;
      			top_sp+=op1.imm.intero;
			if(top_sp > MAX_STACK)
				{
				printf("Stack overflow : Ricompilare aumentando MAX_STACK\n");
				exit(-1); 
				}
      			break;

      default	   :    printf("Istruzione Illegale ! \n");
			exit(-1); 
      }
}


void print_stack()
{
int i;
fprintf(file_output,"pc                 = %d\n",pc);
fprintf(file_output,"top_sp             = %d\n",top_sp);
fprintf(file_output,"livello corrente   = %d\n",level);
fprintf(file_output,"BASE               = %d\n",BASE);
fprintf(file_output,"display            = ");
for (i=0;i<10;i++)
	fprintf(file_output,"[ %3d ]",display[i]);
fprintf(file_output,"\n");

fprintf(file_output,"stack[BASE]        = ");
for (i=0;i<10;i++)
	fprintf(file_output,"[ %3d ]",stack[BASE+i]);
fprintf(file_output,"\n");	

fprintf(file_output,"stack[top_sp]      = ");
for (i=0;i<10;i++)
	fprintf(file_output,"[ %3d ]",stack[top_sp+i]);
fprintf(file_output,"\n");	

for (i=0;i<50;i++)
	{
	if( !(i % 10)) 
	   fprintf(file_output,"\nmem[%2d]            = ",i);
	fprintf(file_output,"[ %3d ]",stack[i]);
	
	}

fprintf(file_output,"\n");	
	


fprintf(file_output,"Control Link       = %d\n",stack[BASE+CTR_OFFS].intero);
fprintf(file_output,"Return Address     = %d\n",stack[BASE+RET_OFFS].intero);
fprintf(file_output,"Saved Base Pointer = %d\n",stack[BASE+SBP_OFFS].intero);
fprintf(file_output,"Level of proc      = %d\n",stack[BASE+LEV_OFFS].intero);
fprintf(file_output,"***********************************************************************\n");	
}

void hal9000()
{
do {
    if (trace_flag) 
    	print_quad(pc);
    	
    run_quad();
    if (trace_flag) 
    	{
    	print_stack();
    	printf("_");
    	getchar();
    	}
    } 
while (quadvect[pc].opcode!=HALT);
}
