%{
%}

EOL	\n
BLANK	[\t ]
LETTERA	[A-Za-z_]
DIGIT   [0-9]
INTERO	{DIGIT}+
EXP	[Ee][-+]?{INTERO}
ID	{LETTERA}({LETTERA}|{DIGIT})*
%s CODICE COMMENTO_GRAFFA COMMENTO_TONDA
%%
			{BEGIN CODICE;}
{EOL}  			{numerolinea++;}
<CODICE>"{"		{BEGIN COMMENTO_GRAFFA; }
<CODICE>"(*"		{BEGIN COMMENTO_TONDA; }
<COMMENTO_GRAFFA>"}"	{ BEGIN CODICE; }
<COMMENTO_TONDA>"*)"	{ BEGIN CODICE; }
<COMMENTO_GRAFFA>.	{ /*SKIP COMMENT*/}
<COMMENTO_TONDA>.	{ /*SKIP COMMENT*/}

<CODICE>const	{return CONST;}
<CODICE>"+"	{yylval.intero=ADD;return addop;}
<CODICE>"-"   	{yylval.intero=SUB;return addop;}
<CODICE>"*"	{yylval.intero=MUL;return mulop;}
<CODICE>"/"   	{yylval.intero=DIV;return mulop;}
<CODICE>mod     {return mod; }
<CODICE>">"	{yylval.intero=GTR; return relop;}
<CODICE>"<"	{yylval.intero=LSS; return relop;}
<CODICE>">="	{yylval.intero=GEQ; return relop;}
<CODICE>"<="	{yylval.intero=LEQ; return relop;}
<CODICE>"="     {yylval.intero=EQ;  return relop;}
<CODICE>"<>"	{yylval.intero=NEQ; return relop;}
<CODICE>":="	{return ASSEGNAMENTO;}
<CODICE>or	{return or; }
<CODICE>and	{return and; }
<CODICE>not	{return not;}
<CODICE>true	{return true;}
<CODICE>false   {return false;}
<CODICE>program	{return PROGRAM;}
<CODICE>var	{return VAR;}
<CODICE>integer	{yylval.intero=INTEGER;return INTEGER;}
<CODICE>real 	{yylval.intero=REAL;return REAL;}
<CODICE>if	{return IF;}
<CODICE>then	{return THEN;}
<CODICE>else	{return ELSE;}
<CODICE>while	{return WHILE;}
<CODICE>do	{return DO;}
<CODICE>begin	{return BEGIN_BLOK;}
<CODICE>end	{return END;}
<CODICE>read	{return READ;}
<CODICE>write	{return WRITE;}
<CODICE>procedure {return PROCEDURE;}
<CODICE>repeat	{return REPEAT;}
<CODICE>until	{return UNTIL;}
<CODICE>for	{return FOR;}
<CODICE>to	{yylval.intero=IADD;return TO;}
<CODICE>downto	{yylval.intero=ISUB;return TO;}
<CODICE>{ID}    {yylval.testo=strdup(yytext);return id;}

<CODICE>{INTERO}  {	yylval.num_sint.type=ICONST;
		yylval.num_sint.val.intero=atoi(yytext);return num;}
<CODICE>{INTERO}("."{INTERO})?({EXP})? 	  {	yylval.num_sint.type=RCONST;
					yylval.num_sint.val.reale=atof(yytext);return num;}
<CODICE>{BLANK}+  {;}

<CODICE>.	  {return yytext[0];}


%%

int yywrap()
{
return 1;
}

