%{
#include<stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#define ALLOCA 
#include "tipi.h"

char *opcode_names[]={ "HALT","GOTO","CALL","RETURN","ALLOC",
		       "READI","WRITEI","IASSIGN","ITOR","MOD",
		       "IADD","ISUB","IMUL","IDIV","IGTR","IGEQ","ILSS","ILEQ","IEQ","INEQ","IUMIN","IPARAM",
		       "RADD","RSUB","RMUL","RDIV","RGTR","RGEQ","RLSS","RLEQ","REQ","RNEQ","RUMIN","RPARAM",
		       "READR","WRITER","RASSIGN"};  


#define YYERROR_VERBOSE 1

struct symbol_tbl tabella_simboli;
p_symbol_tbl p_tabella=&tabella_simboli;


int 		i,nextquad,level,offset,new_temp,top,size,prima_const,prima_var,numero_parametri;;
operandi 	op1,op2,op3;
istr_opcode 	op;
sym_elem	elem;

lista 		p_Lista1,p_Lista2 ;
char		buf1[20],buf2[20],buf3[20];


#define MAXNEST		100


int 		size_stack[MAXNEST];
int 		next_sym_stack[MAXNEST];
int		prima_var_stack[MAXNEST];
int		prima_const_stack[MAXNEST];

void del_temp(op_indir Sx);					
void emit(istr_opcode op, operandi op1,operandi op2, operandi op3);
void print_quad(int quad);
s_expr_attrib chktype_emit(s_expr_attrib a,int op, s_expr_attrib b);
 
%}

%union {
	char 			*testo; 
	int			intero;
	parametri_attrib	param_list;
	coda			nextlist;
	expressione_attrib	expression_sint;
	s_expr_attrib   	s_expr_sint;
	num_attrib		num_sint;
	}
%token <intero>ICONST 2048 INTEGER 2049 RCONST 2050 REAL 2051 PROCEDURE 4096
%token ADD SUB MUL DIV GTR,GEQ,LSS,LEQ,EQ,NEQ	ASSEGNAMENTO 
%token true false PROGRAM CONST VAR READ WRITE IF THEN ELSE WHILE DO BEGIN_BLOK END REPEAT UNTIL FOR 

%left ')'
%right ';'

%left or
%left and
%right not
%nonassoc THEN
%nonassoc ELSE

%token <intero> mulop addop relop mod TO

%left addop
%right UMINUS

%token <testo> id

%token <num_sint> num 

%type <param_list> lista_par_typed lista_parametri argomenti Elist procedure_call
%type <nextlist> istruzione N lista_istruzioni 
%type <s_expr_sint> s_expr factor term 
%type <expression_sint>espressione
%type <intero>M
%type <intero> tipo lista_id_tipata dichiarazioni testa_procedura 

%%
programma	: PROGRAM id '(' lista_id ')' ';' dichiarazioni 	{op1.ind.level=NOLEVEL;
									 op1.imm.intero=size+PROC_HEADER;
									 emit(ALLOC,op1,op2,op3);
									 op1.ind.level=NOLEVEL;
									 emit(GOTO,op1,op2,op3);  /* goto start */
									} 
		  procedure 						{}
		  BEGIN_BLOK 						{quadvect[1].op1.imm.intero=nextquad;} 
		  lista_istruzioni END '.' 				{backpatch($13,nextquad);emit(HALT,op1,op2,op3); }
		;

lista_id	: id			{}
		| lista_id ',' id	{}
		;
		
dichiarazioni	:  							{prima_const=p_tabella->next_free_sym;} 
			const_decls  					{prima_var=p_tabella->next_free_sym-numero_parametri;} 
			var_decls 					{ new_temp=(size=p_tabella->next_free_sym-prima_var);
					  				  if (verbose_flag) fprintf(file_output,"Size Variabili = %d\nOffset t1 = %d\n",size,new_temp); 
					 				 $$=size;}
		;


var_decls	: VAR id lista_id_tipata  {
							elem.type=$3;
							elem.name=$2;
							elem.val.reale=0; /* inizializzo la variabile a zero */
							elem.ind.level=level;
							elem.ind.offset=p_tabella->next_free_sym-prima_var;
							i=insert(p_tabella,elem); 
							if (i<0) YYABORT;
						  	else
							if (verbose_flag) fprintf(file_output,"%3d: %10s = <%d,%d>\n",i,elem.name,p_tabella->symbol[i].ind.level,p_tabella->symbol[i].ind.offset);
 							}
		| var_decls ';' var_decls			{}
		| /*   */
		;
lista_id_tipata	: ',' id lista_id_tipata { 
					  $$=$3;
					  elem.type=$3;
					  elem.name=$2;
					  elem.ind.level=level;
					  elem.ind.offset=p_tabella->next_free_sym-prima_var;
					  i=insert(p_tabella,elem);
					  if (i<0) YYABORT;
						  else 
					  if (verbose_flag) fprintf(file_output,"%3d: %10s = <%d,%d>\n",i,elem.name,p_tabella->symbol[i].ind.level,p_tabella->symbol[i].ind.offset);
					   }
		| ':' tipo  { $$=$2;}
		;

tipo		:  INTEGER
		|  REAL	
		;

procedure	: procedure procedura ';'			{}
		| /*   */
		;

procedura	: testa_procedura dichiarazioni procedure BEGIN_BLOK   	{ p_tabella->symbol[$1].prima_quad=nextquad;
									  p_tabella->symbol[$1].size=size;	
									  op1.ind.level=NOLEVEL;
						   			  op1.imm.intero=p_tabella->symbol[$1].size+PROC_HEADER;
								   	  emit(ALLOC,op1,op2,op3);
						   	
									 }
		  lista_istruzioni END 					{ 						
									  op1.ind.level=NOLEVEL;op1.imm.intero=size+PROC_HEADER; /* potevo sintetizzarlo ma gia' c' e!*/
									  backpatch($6,nextquad);
									  emit(RETURN,op1,op2,op3);
									  level--; 		  /*	pop(procedure info)  */						   
									  size			 = size_stack[level];new_temp=size;
									  p_tabella->next_free_sym = next_sym_stack[level];
									  prima_var		 = prima_var_stack[level];
									  prima_const		 = prima_const_stack[level];
									}
		;

		

testa_procedura : PROCEDURE id 		{ elem.type=PROCEDURE;
					  elem.name=$2;
					  elem.val.reale=0; 			/* qua posso mettere il numero dei parametri */
					  elem.ind.level=level;
					  elem.ind.offset=p_tabella->next_free_sym-prima_var;
					  i=insert(p_tabella,elem); 
					 if (i<0) YYABORT;
					$<intero>$=i; 					/* sintetizzo l' entry nell symbol table per quasta procedura */
					if (verbose_flag) fprintf(file_output,"%3d:procedure %10s = <%d,%d>\n",i,elem.name,p_tabella->symbol[i].ind.level,p_tabella->symbol[i].ind.offset);
					
					size_stack[level]	= size;							/*   push(procedure info) */
					next_sym_stack[level]	= p_tabella->next_free_sym;
					prima_var_stack[level]	= prima_var;
					prima_const_stack[level]= prima_const	;
					{prima_var=p_tabella->next_free_sym;} 
					level++;
					}
		  argomenti ';'		{ numero_parametri=$4.numero_parametri;
		  			p_tabella->symbol[$<intero>3].numero_parametri=numero_parametri;
		  			p_tabella->symbol[$<intero>3].param_list=$4.lista_parametri.testa; 
		  			if (verbose_flag) fprintf(file_output,"Procedura con %d parametri ",$4.numero_parametri);
		  			p_Lista1=$4.lista_parametri.testa;
		  			while(p_Lista1 != NULL)
		  			 	{
		  			 	if (verbose_flag) fprintf(file_output," %s ",p_Lista1->elem == INTEGER ? "INTEGER" : "REAL");
		  			 	p_Lista1=p_Lista1->next;
		  			 	}
		  			 	if (verbose_flag) fprintf(file_output,"\n"); 
		  			 $$=$<intero>3; 				/* sintetizzo l' entry nell symbol table per quasta procedura */
						
		  			}	
		;

argomenti	:  /*     */ 					{$$.lista_parametri.coda=$$.lista_parametri.testa=NULL;$$.tipo=0;$$.numero_parametri=0;}
		|'(' lista_parametri ')'			{$$=$2;}
		;
	
lista_parametri	: id lista_par_typed  				{$$.lista_parametri=merge(makelist($2.tipo),$2.lista_parametri);$$.numero_parametri=$2.numero_parametri+1;
								 elem.type=$2.tipo;
					  			 elem.name=$1;
					  			 elem.ind.level=level;
					  			 elem.ind.offset=p_tabella->next_free_sym-prima_var;
					  			 i=insert(p_tabella,elem);
								 if (i<0) YYABORT;
								  else 
					 			 if (verbose_flag) fprintf(file_output,"%3d: PARAM %10s = <%d,%d>\n",i,elem.name,p_tabella->symbol[i].ind.level,p_tabella->symbol[i].ind.offset);}
		| lista_parametri ';' lista_parametri  	       {
								$$.lista_parametri = merge($1.lista_parametri,$3.lista_parametri);
								$$.numero_parametri= $1.numero_parametri+$3.numero_parametri;
								}
		;
lista_par_typed	:  ',' id lista_par_typed 			{$$.lista_parametri=merge(makelist($3.tipo),$3.lista_parametri);$$.tipo=$3.tipo;$$.numero_parametri=$3.numero_parametri+1;
								elem.type=$3.tipo;
					  			elem.name=$2;
					  			elem.ind.level=level;
					  			elem.ind.offset=p_tabella->next_free_sym-prima_var;
					  			i=insert(p_tabella,elem);
								 if (i<0) YYABORT;
								  else 
					 			 if (verbose_flag) fprintf(file_output,"%3d: PARAM %10s = <%d,%d>\n",i,elem.name,p_tabella->symbol[i].ind.level,p_tabella->symbol[i].ind.offset);
								}
		|  ':' tipo 					{$$.lista_parametri.coda=$$.lista_parametri.testa=NULL;$$.tipo=$2;$$.numero_parametri=0;}
		;		
						
lista_istruzioni: istruzione					{   $$=$1;   }
		| lista_istruzioni ';' M istruzione  		{  backpatch($1,$3);$$=$4; }
		;

istruzione	: id ASSEGNAMENTO s_expr   {  $$.testa=$$.coda=NULL; 
						i=find(p_tabella,$1);
						if(i>=0)
						{ if ((p_tabella->symbol[i].type & INTEGER)== INTEGER)   /* se e' una costante  stampo errore */
						      if(p_tabella->symbol[i].type >= $3.type)		 /* se l-type >= r-type   stampo errore */
						      { 
						      op3.ind=p_tabella->symbol[i].ind;    	/* imposto come destinazione l' indirizzo della variabile */
						      	if (p_tabella->symbol[i].type == INTEGER)      
						      		switch($3.type)
						      			{
						      			case ICONST :  emit(IASSIGN,$3.place,op3,op3);break;
						  				/* se era un temporaneo modifico la quadrupla */					  						  							  
						      			case INTEGER:	if(($3.place.ind.level==level )&&($3.place.ind.offset>=size))
						      					  if (quadvect[(nextquad-1)].opcode==IUMIN)
						      					   	{ quadvect[(nextquad-1)].op2=op3;new_temp--;	}
											   else	{ quadvect[(nextquad-1)].op3=op3;new_temp--;	}
						      					else emit(IASSIGN,$3.place,op3,op3);
						      					break;
						      			}						   		
						      	else /* id.type == reale */ switch($3.type)				/* id e' una variabile reale */
						      			{
						      			case ICONST :	$3.place.imm.reale=$3.place.imm.intero; /* cast statico  se occorre no-break*/
									case RCONST :	emit(RASSIGN,$3.place,op3,op3);break;	/* e RASSIGN in entrambi i caso */	
						      			case INTEGER:	emit(ITOR,$3.place,op3,op3);del_temp($3.place.ind);break;
						      			case REAL   :	if(($3.place.ind.level==level )&&($3.place.ind.offset>=size))   	
						      					   if (quadvect[(nextquad-1)].opcode==RUMIN)
						      					   	{ quadvect[(nextquad-1)].op2=op3;new_temp--;	}
											   else	{ quadvect[(nextquad-1)].op3=op3;new_temp--;	}
						      					else emit(RASSIGN,$3.place,op3,op3);

						      				     	break;
						      			}					
						      }
			      			else {fprintf(file_errori,"linea %d: errore di tipo nell' assegnamento %s := exp\n",numerolinea,$1);YYABORT;} 
		 		 	else {fprintf(file_errori,"linea %d: Il simbolo %s non e' un valido l-value\n",numerolinea,$1);YYABORT;} 
					}
				else  {fprintf(file_errori,"linea %d: Simbolo '%s' non dichiarato\n",numerolinea,$1);YYERROR;}
					   } /* fine ASSEGNEMENTO */

		| IF espressione THEN M istruzione 			{ backpatch( $2.truelist,$4);  $$=merge($2.falselist,$5);   }
		| IF espressione THEN M istruzione ELSE N M istruzione 	{ backpatch( $2.truelist,$4);  backpatch( $2.falselist,$8);
									  $$=merge($7,$9); $$=merge($5,$$);   				
									} 				
		| WHILE M espressione DO M istruzione			{ backpatch($6,$2); backpatch($3.truelist,$5);
									  $$=$3.falselist;  
									  op1.ind.level=NOLEVEL;op1.imm.intero=$2;
									  emit(GOTO,op1,op2,op3);
									}
		| REPEAT M lista_istruzioni UNTIL M espressione		{ backpatch($3,$5); backpatch($6.falselist,$2); 
									  $$=$6.truelist;
									  op1.ind.level=NOLEVEL;op1.imm.intero=$2;
									  emit(GOTO,op1,op2,op3);
									}
		| FOR id ASSEGNAMENTO s_expr TO  	{  
							i=find(p_tabella,$2);
							if(i>=0)
							  if (p_tabella->symbol[i].type == INTEGER)   		/* se non e' un intero  stampo errore */
						      		if(p_tabella->symbol[i].type >= $4.type)	/* se l-type < r-type   stampo errore */
						      		{ 
						      		$<intero>$=i;					/* simtetizzo la variabile di controllo */
						      		op3.ind=p_tabella->symbol[i].ind;    		/* imposto come destinazione l' indirizzo della variabile */
						       		switch($4.type)
						      			{
						      			case ICONST :   emit(IASSIGN,$4.place,op3,op3);break;
						  			  					/* se era un temporaneo modifico la quadrupla */					  						  					
						  		   	case INTEGER:	if(($4.place.ind.level==level )&&($4.place.ind.offset>=size))
						  		   				if (quadvect[(nextquad-1)].opcode==IUMIN)
						      					   		{ quadvect[(nextquad-1)].op2=op3;new_temp--;	}
											   	else	{ quadvect[(nextquad-1)].op3=op3;new_temp--;	}
						      					else emit(IASSIGN,$4.place,op3,op3);
						      					break;
						      			}
						      		}						   		
						        	else {fprintf(file_errori,"linea %d: errore di tipo nell' assegnamento %s := exp\n",numerolinea,$2);YYABORT;} 
		 		 			  else {fprintf(file_errori,"linea %d: Il simbolo %s non e' un integer\n",numerolinea,$2);YYABORT;} 
						    else  {fprintf(file_errori,"linea %d: Simbolo '%s' non dichiarato\n",numerolinea,$2);YYERROR;}
						  } 
		  M s_expr DO 	istruzione		{ $$=merge(makelist(nextquad),$10);	 
		  					op1.ind=p_tabella->symbol[$<intero>6].ind;
		  					op3.ind.level=NOLEVEL;
		  					emit(IEQ,op1,$8.place,op3);
		  							  					
		  
		 					op = $5;					/* op = IADD se 'for n to N', op=ISUB se  'for n downto N' */
		  					op1.ind = p_tabella->symbol[$<intero>6].ind;   
		  					op2.ind.level = NOLEVEL; op2.imm.intero=1;
		  					emit(op,op1,op2,op1);				/* n := n+1	*/
		  					op1.ind.level=NOLEVEL; op1.imm.intero=$7;
		  					emit(GOTO,op1,op2,op3);	
		  												 								
		  					}
		  
		| BEGIN_BLOK lista_istruzioni END	{ $$=$2; }
		| procedure_call			{$$.testa=$$.coda=NULL; }
		| READ '(' id ')'	{	$$.testa=$$.coda=NULL; 
					i=find(p_tabella,$3);
						  if(i>=0)			
							switch(p_tabella->symbol[i].type)
							  { case ICONST: case RCONST: 	fprintf(file_errori,"linea %d: READ(%s) argomento costante\n",numerolinea,p_tabella->symbol[i].name);
							  				YYABORT; break;
							    case INTEGER:op1.ind=p_tabella->symbol[i].ind;emit(READI,op1,op2,op3);break;
							    case REAL:	 op1.ind=p_tabella->symbol[i].ind;emit(READR,op1,op2,op3);break;	
							  }
						  else {fprintf(file_errori,"linea %d: Simbolo '%s' non dichiarato\n",numerolinea,$3);YYERROR;}
					 
					}
		| WRITE '(' id ')'	{   $$.testa=$$.coda=NULL; 
						i=find(p_tabella,$3);
						  if(i>=0)switch(p_tabella->symbol[i].type)
							  { case ICONST:  op1.imm=p_tabella->symbol[i].val;
									  op1.ind.level=NOLEVEL;
									  emit(WRITEI,op1,op2,op3);break;					
							    case RCONST:  op1.imm=p_tabella->symbol[i].val;
									  op1.ind.level=NOLEVEL;
									  emit(WRITER,op1,op2,op3);break;					
							    case INTEGER:op1.ind=p_tabella->symbol[i].ind;emit(WRITEI,op1,op2,op3);break;	
							    case REAL:	 op1.ind=p_tabella->symbol[i].ind;emit(WRITER,op1,op2,op3);break;	
							  }			
						 else {fprintf(file_errori,"linea %d: Simbolo '%s' non dichiarato\n",numerolinea,$3);YYERROR;}
					 
					}
		;

procedure_call	: id			{ i=find(p_tabella,$1);
						  if((i>=0) && p_tabella->symbol[i].type==PROCEDURE)	
						   {
						   if(p_tabella->symbol[i].numero_parametri==0)
						   	{
						   	if (verbose_flag) fprintf(file_output,"invocata procedure %s num_par %d \n",$1,p_tabella->symbol[i].numero_parametri);
						   	
						   	//op1.ind.level=NOLEVEL;
						   	//op1.imm.intero=p_tabella->symbol[i].size+PROC_HEADER;
						   	//emit(ALLOC,op1,op2,op3);
						   	
						   	op1.ind.level=NOLEVEL;op1.imm.intero=p_tabella->symbol[i].ind.level+1; /* emetto il nesting level delle variabili della procedure chiamata */
						   	emit(IPARAM,op1,op2,op3);
						   	op1.ind.level=NOLEVEL;op1.imm.intero=p_tabella->symbol[i].prima_quad;
						   	emit(CALL,op1,op2,op3);
						   	}
						   else 	
						   { yyerror("numero parametri errato, non sono mica un compilatore java !\n"); YYABORT;}	
						   }						  
						   else { yyerror("procedure non definita");YYABORT; }
					}

		| id '(' Elist ')'	{ i=find(p_tabella,$1);					
						  if((i>=0) && p_tabella->symbol[i].type==PROCEDURE)	
						   {
						   if(p_tabella->symbol[i].numero_parametri==$3.numero_parametri)
						   	{ 
						   	p_Lista1=p_tabella->symbol[i].param_list;
						   	p_Lista2=$3.lista_parametri.testa;
					   		if (verbose_flag) fprintf(file_output,"procedure %s num_par %d ",$1,p_tabella->symbol[i].numero_parametri);
					   		
					   		//op1.ind.level=NOLEVEL;
						   	//op1.imm.intero=p_tabella->symbol[i].size+PROC_HEADER;
						   	//emit(ALLOC,op1,op2,op3);
						   	
					   		op1.ind.level=NOLEVEL;op1.imm.intero=p_tabella->symbol[i].ind.level+1;  /* emetto il nesting level della procedure chiamata */
					   		emit(IPARAM,op1,op2,op3);
						   	
					   		
					   		while((p_Lista1 != NULL) && (p_Lista2 != NULL))
					   		{
					   		if ( p_tabella->symbol[p_Lista2->elem].type == p_Lista1->elem)
					   			{
					   			if (verbose_flag) fprintf(file_output," %s ", p_tabella->symbol[p_Lista2->elem].type == INTEGER ? "INTEGER" :"REAL");	
				   				op=p_tabella->symbol[p_Lista2->elem].type == INTEGER ? IPARAM : RPARAM;
				   				op1.ind=p_tabella->symbol[p_Lista2->elem].ind;
				   				emit(op,op1,op2,op3);	
					   			p_Lista1 = p_Lista1->next;					   			
					   			p_Lista2 = p_Lista2->next;				   			
					   			}
					   		else 	{ yyerror("tipo dei parametri errato, non sono mica un compilatore java !\n"); YYABORT;}
						   	} 
						  
		  			 	   	op1.ind.level=NOLEVEL;op1.imm.intero=p_tabella->symbol[i].prima_quad;		  			 
						   	emit(CALL,op1,op2,op3);
						   	}
						   else 	
						   	{ yyerror("numero parametri errato, non sono mica un compilatore java !\n"); YYABORT;}	
						    
						    } 
					      else { yyerror("procedure non definita");YYABORT; }
					}
		;
Elist		:  Elist ',' id		{i=find(p_tabella,$3);					
						  if((i>=0) && p_tabella->symbol[i].type!=PROCEDURE)
						  {
						  $$.lista_parametri=makelist(i);
						  $$.lista_parametri=merge($1.lista_parametri,$$.lista_parametri);
						  $$.numero_parametri=1+$1.numero_parametri;
						  }
					else { yyerror("simbolo non definito");YYABORT; }	 
					
						  } 								/* per adesso solo id, in seguit s_expr */
		|  id			{i=find(p_tabella,$1);					
						  if((i>=0) && p_tabella->symbol[i].type!=PROCEDURE)
						  {
						  $$.lista_parametri=makelist(i);
						  $$.numero_parametri=1;
						  }
					else { yyerror("simbolo non definito");YYABORT; }	 
					}
		;
espressione 	: espressione 	or  M espressione 	{ backpatch($1.falselist,$3); $$.truelist=merge($1.truelist,$4.truelist); $$.falselist=$4.falselist; }
		| espressione 	and M espressione 	{ backpatch($1.truelist,$3);  $$.truelist=$4.truelist; $$.falselist=merge($1.falselist,$4.falselist);}
		| not espressione			{ $$.truelist=$2.falselist; $$.falselist=$2.truelist; }
		| '(' espressione ')'			{ $$=$2; }
		| s_expr relop s_expr			{ 
							if((($1.type | $3.type) & INTEGER) == ICONST)  /* se cioe' entrambi sono costanti 				*/
								{ 
								if($1.type == ICONST)			/*se e' di tipo intero lo converto in reale staticamente     	*/ 
									$1.place.imm.reale=$1.place.imm.intero;
								if($3.type == ICONST)			/*se e' di tipo intero lo converto in reale staticamente     	*/ 
									$3.place.imm.reale=$3.place.imm.intero;	
								switch($2)   
							  				    	{
							  				    	case GTR: i=($1.place.imm.reale >  $3.place.imm.reale) ? VERO : FALSO;break;
			/* CONST relop CONST */		  				    	case GEQ: i=($1.place.imm.reale >= $3.place.imm.reale) ? VERO : FALSO;break;
							  				    	case LSS: i=($1.place.imm.reale <  $3.place.imm.reale) ? VERO : FALSO;break;
							  				    	case LEQ: i=($1.place.imm.reale <= $3.place.imm.reale) ? VERO : FALSO;break;
							  				    	case EQ:  i=($1.place.imm.reale == $3.place.imm.reale) ? VERO : FALSO;break;
							  				    	case NEQ: i=($1.place.imm.reale != $3.place.imm.reale) ? VERO : FALSO;break;
							  				    	} 
							  	if (i)	{ $$.truelist =makelist(nextquad); $$.falselist.testa=$$.falselist.coda=NULL; op1.ind.level=NOLEVEL; emit(GOTO,op1,op2,op3); }
									else { $$.falselist=makelist(nextquad); $$.truelist.testa=$$.truelist.coda=NULL;   op1.ind.level=NOLEVEL; emit(GOTO,op1,op2,op3); }
								} 
								else 									 /* se cioe' non sono  entrambi costanti 		*/	
	/* INTEGER relop INTEGER  ||  REAL relop REAL */  	if( (($1.type & $3.type)==REAL) ||  (($1.type | $3.type) == INTEGER) )   /* se sono entrambi di tipo double o entrambi di tipo intero */
								  	{
								  	op=(($1.type | $3.type) == INTEGER) ? IADD + ($2- ADD):	RADD + ($2- ADD); /* scelgo fra confronto intero o reale */							  	
								  	$$.truelist  = makelist(nextquad);
							  		$$.falselist = makelist(nextquad+1);  
						  	  		op3.ind.level=NOLEVEL;
								  	op3.imm.intero=777;
							  		emit(op,$1.place,$3.place,op3);
							  		del_temp($1.place.ind);del_temp($3.place.ind);  /* aggiorno i temporanei */
							  		op1.ind.level=NOLEVEL;
							  		op3.imm.intero=777;
							  		emit(GOTO,op1,op2,op3);	
							  		}
							  	else
							switch ($1.type)
							  {
			/* ICONST relop REAL */		case ICONST : $1.place.imm.reale=$1.place.imm.intero;	/* allora il $3 deve essere REAL: ICONST--> cast statico*/
							  		$$.truelist  = makelist(nextquad);
							  		$$.falselist = makelist(nextquad+1);  
						  	  		op3.ind.level=NOLEVEL;
								  	op3.imm.intero=777;
							  		emit(RADD + ($2- ADD),$1.place,$3.place,op3);
							  		del_temp($3.place.ind);  		/* aggiorno i probabili temporanei, $1 e' costante dunque non controllo */
							  		op1.ind.level=NOLEVEL;
							  		op3.imm.intero=777;
							  		emit(GOTO,op1,op2,op3);		
							  		break;
			/* RCONST relop INTEGER */   	case RCONST : 	op1.ind.level=level;   		/* allora il $3 deve essere INTEGER: --> ITOR        */
									del_temp($3.place.ind);
									op1.ind.offset=new_temp;	/* non incremento perche' riutilizzo subito dopo */
									emit(ITOR,$3.place,op1,op3); 
										 				
							  		$$.truelist  = makelist(nextquad);
							  		$$.falselist = makelist(nextquad+1);  
						  	  		op3.ind.level=NOLEVEL;
								  	op3.imm.intero=777;
							  		emit(RADD + ($2- ADD),$1.place,op1,op3); 
							  		op1.ind.level=NOLEVEL;
							  		op3.imm.intero=777;
							  		emit(GOTO,op1,op2,op3);		
							  		break;
							  case INTEGER:switch ($3.type)
							  			{
							  			case RCONST :	/* identico trattamento di INTEGER relop REAL */
							  			case REAL:	op1.ind.level=level;   		
												del_temp($1.place.ind);
												op1.ind.offset=new_temp;	/* non incremento perche' riutilizzo subito dopo */
												emit(ITOR,$1.place,op1,op3); 
									
							  					$$.truelist  = makelist(nextquad);
							 				 	$$.falselist = makelist(nextquad+1); 
						  	  					op3.ind.level=NOLEVEL;
							  					op3.imm.intero=777;
							  					emit(RADD + ($2- ADD),op1,$3.place,op3);
							  					op1.ind.level=NOLEVEL;
							  					op3.imm.intero=777;
							 					emit(GOTO,op1,op2,op3);
							 					break;	
							  			}
							  		break;
							  case REAL   :switch ($3.type)
							  			{
							  			case ICONST :	$3.place.imm.reale=$3.place.imm.intero;		/*  cast statico*/
							  					$$.truelist  = makelist(nextquad);
							  					$$.falselist = makelist(nextquad+1);  
									  	  		op3.ind.level=NOLEVEL;
											  	op3.imm.intero=777;
										  		emit(RADD + ($2- ADD),$1.place,$3.place,op3);
										  		del_temp($1.place.ind);  /* aggiorno i temporanei */
							  					op1.ind.level=NOLEVEL;
										  		op3.imm.intero=777;
										  		emit(GOTO,op1,op2,op3);		
										  		break;
							  			case INTEGER:	op2.ind.level=level;   		
												del_temp($3.place.ind);
												op2.ind.offset=new_temp;	/* non incremento perche' riutilizzo subito dopo */
												emit(ITOR,$3.place,op2,op3); 
									
							  					$$.truelist  = makelist(nextquad);
							 				 	$$.falselist = makelist(nextquad+1); 
						  	  					op3.ind.level=NOLEVEL;
							  					op3.imm.intero=777;
							  					emit(RADD + ($2- ADD),$1.place,op2,op3);
							  					op1.ind.level=NOLEVEL;
							  					op3.imm.intero=777;
							 					emit(GOTO,op1,op2,op3);
							 					
							  					break;
										
							  			}
							  		break;
							  default :		yyerror("ERRORE CASO NON CONTEPLATO s_expr relo s_expr\n");
							  		}  /* end switch*/
							  	
							 	
							   }
		| true				{ $$.truelist =makelist(nextquad); $$.falselist.testa=$$.falselist.coda=NULL; op1.ind.level=NOLEVEL; emit(GOTO,op1,op2,op3); }
		| false				{ $$.falselist=makelist(nextquad); $$.truelist.testa=$$.truelist.coda=NULL;   op1.ind.level=NOLEVEL; emit(GOTO,op1,op2,op3); }
		;
M		:	 	{$$=nextquad;}
		;

N		:		{ $$=makelist(nextquad); op1.ind.level=NOLEVEL; op1.imm.intero = 333; emit(GOTO,op1,op2,op3); }
		;
				
const_decls	: CONST lista_const ';'	const_decls
		|	
		;

lista_const	: cds 
		| lista_const ',' cds
		;
cds		: id relop num 		       { if ($2 != EQ)  
						  { yyerror("parse error, expecting '='");YYERROR;}
						  elem.type=($3.type==ICONST)? ICONST:RCONST;
						  elem.name=$1;
						  elem.val=$3.val;
						  elem.ind.level=level;
						  elem.ind.offset=p_tabella->next_free_sym-prima_const;							
						  i=insert(p_tabella,elem);
						  if (i<0) YYABORT;
						  else
						  if (p_tabella->symbol[i].type==ICONST )
					  	     	if (verbose_flag) fprintf(file_output,"%3d: %10s = <%d,%d> ICONST = %d\n",i,elem.name,p_tabella->symbol[i].ind.level,p_tabella->symbol[i].ind.offset,p_tabella->symbol[i].val.intero); 
					  	   else   
					  	  	if (verbose_flag) fprintf(file_output,"%3d: %10s = <%d,%d> RCONST = %e\n",i,elem.name,p_tabella->symbol[i].ind.level,p_tabella->symbol[i].ind.offset,p_tabella->symbol[i].val.reale); 
						 }  
		;
		
s_expr		: s_expr addop term 		{ $$=chktype_emit($1,$2,$3);}
		| addop s_expr %prec UMINUS	{if ($1 == ADD) $$=$2; 
							else	
						switch ($2.type)    /* OCCORRE OP2= NEWTEMP */
						 {
						 case ICONST	:$2.place.imm.intero=-$2.place.imm.intero;$$=$2;$$=$2;break;
						 case RCONST	:$2.place.imm.reale=-$2.place.imm.reale;$$=$2;  $$=$2;break;
						 case INTEGER	:del_temp($2.place.ind);op2.ind.level=level;op2.ind.offset=new_temp++;emit(IUMIN,$2.place,op2,op3);$$.type=INTEGER;$$.place=op2; break;
						 case REAL	:del_temp($2.place.ind);op2.ind.level=level;op2.ind.offset=new_temp++;emit(RUMIN,$2.place,op2,op3);$$.type=REAL;$$.place=op2;    break;
						
						                /* emit(po,op1,p2,p3); */
			                           }
						}					
 		| term				{$$=$1;	}			
		;
		
term		: term mulop factor	{ $$=chktype_emit($1,$2,$3);}		
		| term mod factor	{ $$.type=($1.type | $3.type);
						if($$.type >INTEGER)  {yyerror("l' operatore 'mod' e' definito solo su interi");YYABORT;} /*tipo double non valido */
					else    if($$.type ==ICONST)  {$$.place.ind.level=NOLEVEL;$$.place.imm.intero=$1.place.imm.intero%$3.place.imm.intero;	}
					else 	{del_temp($1.place.ind);del_temp($3.place.ind);
						 op3.ind.level=level;op3.ind.offset=new_temp++;
						 emit(MOD,$1.place,$3.place,op3);
						 $$.place=op3;
						}
					}
		| factor 		{$$=$1;	}
		;

factor		: num			{
					$$.type=$1.type;
					$$.place.imm=$1.val;
					$$.place.ind.level=NOLEVEL;
					}
		| '(' s_expr ')'	{$$=$2;} 	
		| id			{					
					i=find(p_tabella,$1);
						  if(i>=0)			
							{
							$$.type=p_tabella->symbol[i].type;
							if(($$.type & INTEGER) == ICONST)  /* se costante sintetizzo il valore altrimenti la locazione */
								{	$$.place.imm=p_tabella->symbol[i].val;
									$$.place.ind.level=NOLEVEL;
								}
							else{	$$.place.ind=p_tabella->symbol[i].ind; }

							 }
						  else {fprintf(file_errori,"linea %d: Simbolo '%s' non dichiarato\n",numerolinea,$1);YYERROR;}
							
					}				
		;	  
%%

#include "lex.yy.c"

/*****************************   yyerror  ***********************/
int yyerror(char *s) 
{
fprintf(file_errori,"linea %d: %s\n",numerolinea,s);
}

void del_temp(op_indir ind)
{
if (ind.level==level)
   if(ind.offset > size) /* se e' stato usato come operando un temporaneo */
                  new_temp--;
}					

/********************  emit ****************************************************/

void emit(istr_opcode op, operandi op1,operandi op2, operandi op3)
{
quadvect[nextquad].opcode=op;
quadvect[nextquad].op1=op1;
quadvect[nextquad].op2=op2;
quadvect[nextquad].op3=op3;
nextquad++;
if (nextquad >= MAX_ISTR)
	{yyerror("Raggiunto il limite massimo per le quadruple\n");
	exit(1);
	}

}


/************************* STAMPA QUADRUPLE ***************************************/


char *print_op(char *buf ,operandi operando,istr_opcode op )
{
if(operando.ind.level==NOLEVEL)		/* se e' un operando immediato 	*/
  {
   if( op < RADD)			/* se opera cioe' su interi  	*/
   sprintf(buf,"<#%d>",operando.imm.intero);
  else sprintf(buf,"<#%e>",operando.imm.reale);
  }
else sprintf(buf,"<%d,%2d>",operando.ind.level,operando.ind.offset); 
return buf;
}

void print_quad(int quad)
{
istr_opcode op;
operandi op1,op2,op3;
op=quadvect[quad].opcode;
op1=quadvect[quad].op1;
op2=quadvect[quad].op2;
op3=quadvect[quad].op3;

fprintf(file_output,"%3d: %-10s",quad,opcode_names[op]);

switch(op)
{
case HALT:	fprintf(file_output,"\n");break;
case GOTO: case CALL:case RETURN:case ALLOC:
case IPARAM:case RPARAM:
case READI:case READR:	
case WRITEI:		
case WRITER:	fprintf(file_output,"%16s\n",print_op(buf1,op1,op));break; 						/* 1 operando */	

case IUMIN: case RUMIN:
case IASSIGN:case RASSIGN:/*   16 SPACE  */
case ITOR:	fprintf(file_output,"%16s                %16s\n",print_op(buf1,op1,op),print_op(buf2,op2,op));break;			/* 2 operandi */

case IGTR:case IGEQ:case ILSS:case ILEQ:case IEQ :case INEQ :case RGTR :case RGEQ :case RLSS :case RLEQ :case REQ:case RNEQ: 
 		fprintf(file_output,"%16s%16s",print_op(buf1,op1,op),print_op(buf2,op2,op));
 		op=IADD;											/* III operando == destinazione :=intero */
		fprintf(file_output,"%16s\n",print_op(buf3,op3,op));break;
default :  	fprintf(file_output,"%16s%16s%16s\n",print_op(buf1,op1,op),print_op(buf2,op2,op),print_op(buf3,op3,op));break;	/* 3 operandi */	

 }

}

/********************* chktype_emit  ************************************************************/

s_expr_attrib chktype_emit(s_expr_attrib S1, int op, s_expr_attrib S3 )
{
s_expr_attrib SS;
SS.type=(S1.type | S3.type);  	/* promuove i tipi 		*/
if ((SS.type & INTEGER) == ICONST) SS.place.ind.level=NOLEVEL;
op=((SS.type & RCONST)==RCONST)? RADD+(op-ADD):IADD+(op-ADD);  /* controla se il tipe e' float */

switch (S1.type)
{

case ICONST:
	switch (S3.type)
		{
		case ICONST: switch(op)   		  	/* sintetizzo  */
					{
					case IADD: SS.place.imm.intero=S1.place.imm.intero+S3.place.imm.intero;break;
					case ISUB: SS.place.imm.intero=S1.place.imm.intero-S3.place.imm.intero;break;
					case IMUL: SS.place.imm.intero=S1.place.imm.intero*S3.place.imm.intero;break;
					case IDIV: if (S3.place.imm.intero==0) yyerror("Divisione per Zero !\n");
						  else SS.place.imm.intero=S1.place.imm.intero/S3.place.imm.intero;break;
					};break;
		case RCONST :		switch(op) 			/* sintetizzo */
					{
					case RADD: SS.place.imm.reale=S1.place.imm.intero+S3.place.imm.reale;break;
					case RSUB: SS.place.imm.reale=S1.place.imm.intero-S3.place.imm.reale;break;
					case RMUL: SS.place.imm.reale=S1.place.imm.intero*S3.place.imm.reale;break;
					case RDIV: if (S3.place.imm.intero==0) yyerror("Divisione per Zero !\n");
						else	SS.place.imm.reale=S1.place.imm.intero/S3.place.imm.reale;break;
					}break;
		case INTEGER:case REAL:	if((S3.type)==INTEGER) op1.imm.intero=S1.place.imm.intero;	/* verifico se occore il cast 	*/
		 	        		else op1.imm.reale=S1.place.imm.intero;			/* se si: cast upcast statico   */
					op1.ind.level=NOLEVEL;
					op3.ind.level=level; 
					del_temp(S3.place.ind);	
					op3.ind.offset=new_temp++;
					emit(op,op1,S3.place,op3);
					SS.place.ind=op3.ind; 
					break;
								
		};break;
case INTEGER:	switch (S3.type) 		/* emit in ogni caso */
		{
		case ICONST: 		op2.imm=S3.place.imm;
					op2.ind.level=NOLEVEL;	
					op3.ind.level=level;
					del_temp(S1.place.ind);
					op3.ind.offset=new_temp++;
					emit(op,S1.place,op2,op3); 
					SS.place.ind=op3.ind; 
					break;
					
		case INTEGER:		del_temp(S1.place.ind);
					del_temp(S3.place.ind);
					op3.ind.level=level; 
					op3.ind.offset=new_temp++;
					emit(op,S1.place,S3.place,op3);
					SS.place.ind=op3.ind; 
					break;
		
		case RCONST: 		del_temp(S1.place.ind);
					op1.ind.level=level;    		/* se S1 e' un temporaneo */
					op1.ind.offset=new_temp;		/* non incremento perche' riutilizzo subito dopo */
					emit(ITOR,S1.place,op1,op3); 
					op2.ind.level=NOLEVEL;
					op2.imm=S3.place.imm;
					op3.ind.level=level; 
					op3.ind.offset=new_temp++;   
					emit(op,op1,op2,op3);  
					SS.place.ind=op3.ind; 
					break;
					
		case REAL:   		op1.ind.level=level;    		
					op1.ind.offset=new_temp;		/* non incremento perche' riutilizzo subito dopo */
					emit(ITOR,S1.place,op1,op3); 
					del_temp(S1.place.ind);
					del_temp(S3.place.ind);
					op3.ind.level=level; 
					op3.ind.offset=new_temp++;   
					emit(op,op1,S3.place,op3);
					SS.place.ind=op3.ind; 
					break;
		
		};break;

case RCONST:switch (S3.type)
		{		
		case ICONST: 		switch(op)  {		 /* sintetizzo  */
					case RADD: SS.place.imm.reale=S1.place.imm.reale+S3.place.imm.intero;break;
					case RSUB: SS.place.imm.reale=S1.place.imm.reale-S3.place.imm.intero;break;
					case RMUL: SS.place.imm.reale=S1.place.imm.reale*S3.place.imm.intero;break;
					case RDIV: if (S3.place.imm.intero==0) yyerror("Divisione per Zero !\n");
						else SS.place.imm.reale=S1.place.imm.reale/S3.place.imm.intero;break;
					}break;
		
		case INTEGER:		del_temp(S3.place.ind);
					op2.ind.level=level;
					op2.ind.offset=new_temp;		/* e non incremento perche' riutilizzero subito dopo */     
					emit(ITOR,S3.place,op2,op3); 
					op1.imm=S1.place.imm;
					op1.ind.level=NOLEVEL;
					op3.ind.level=level; 
					op3.ind.offset=new_temp++;
					emit(op,op1,op2,op3);	
					SS.place.ind=op3.ind; 
					break;
		case RCONST: 	switch(op) {	/* sintetizzo  */
					case RADD: SS.place.imm.reale=S1.place.imm.reale+S3.place.imm.reale;break;
					case RSUB: SS.place.imm.reale=S1.place.imm.reale-S3.place.imm.reale;break;
					case RMUL: SS.place.imm.reale=S1.place.imm.reale*S3.place.imm.reale;break;
					case RDIV: if (S3.place.imm.reale==0) yyerror("Divisione per Zero !\n");
							else SS.place.imm.reale=S1.place.imm.reale/S3.place.imm.reale;break;
					}break;
					
		case REAL:   		op1.imm=S1.place.imm;
					op1.ind.level=NOLEVEL;
					op3.ind.level=level; 
					op3.ind.offset=new_temp++;
					emit(op,op1,S3.place,op3);
					del_temp(S3.place.ind);
					SS.place.ind=op3.ind; 
					break;
		};break;

case REAL:switch (S3.type)
		{		
		case ICONST:case RCONST: if (S3.type == ICONST)
						op2.imm.reale=S3.place.imm.intero;
					  else op2.imm=S3.place.imm;
					op2.ind.level=NOLEVEL;					
					op3.ind.level=level; 
					op3.ind.offset=new_temp++;
					emit(op,S1.place,op2,op3);
					del_temp(S1.place.ind);	
					SS.place.ind=op3.ind; 
					break;
										
		case INTEGER:		op2.ind.level=level;
					op2.ind.offset=new_temp;   /* non incremento perche riutilizzero almeno un temp */
					emit(ITOR,S3.place,op2,op3); 
					del_temp(S3.place.ind);
					op3.ind.level=level; 
					op3.ind.offset=new_temp++;
					emit(op,S1.place,op2,op3);
					del_temp(S1.place.ind);		
					SS.place.ind=op3.ind; 	
					break;
						
						
		case REAL:  		op3.ind.level=level; 
					op3.ind.offset=new_temp++;
					emit(op,S1.place,S3.place,op3);
					del_temp(S1.place.ind);	del_temp(S3.place.ind);	
					SS.place.ind=op3.ind; 
					break;			
		};break;


} 

return SS;
}



int main(int argc,char *argv[])
{

int i,c;

p_tabella->next_free_sym=0;
nextquad=0;

while(1)
{
c=getopt(argc,argv,"o:e:vhHtrsl");
if (c == -1) break;
switch(c)
{	
case 'o':	file_output=fopen(optarg,"w");
		if(file_output == NULL){
			fprintf(file_errori,"Impossibile aprire file di output %s\n",optarg);
			file_output=stdout;}
		break;

case 'e':       file_errori=fopen(optarg,"w");
		if (file_errori == NULL)
			{
			file_errori=stderr;
			fprintf(file_errori,"Impossibile aprire file di errori %s\n",optarg);
			}
		break;
case 't':	yydebug = 1;
#if YYDEBUG != 1
printf("Per attivare il trace occorre ricompilare con YACC -t\n");
#endif
	
		break;
case 'r':	run_flag     = 1;printf("Run\n");break;
case 's':	trace_flag   = 1;printf("Trace\n");break;		
case 'l':	list_flag    = 1;printf("List\n");break;		
case 'v':	verbose_flag = 1;printf("Verbose\n");break;
case	'h':case 'H':	printf("\n%s versione del %s\n",argv[0],__DATE__);
default:		printf("\nUSO: %s \t-opzioni filename[.pas] \n\n",argv[0]);
			printf("\t\t-h Help\n");
			printf("\t\t-o out_filename\n");
			printf("\t\t-e error_filename\n");
			printf("\t\t-t trace-mode del parser se compilato con YACC -t \n");
			printf("\t\t-l listato quadruple\n");
			printf("\t\t-v visualizza informazioni sulla symbol table\n");
			printf("\t\t-r run program\n");
			printf("\t\t-s stack-print e trace-mode di HAL 9000\n");
			printf("\n");
			exit(0);
	 	   }
} 

if (optind < argc)
{
file_input=fopen(argv[optind],"r");
if (file_input == NULL)
	fprintf(file_errori,"Impossibile aprire file di input %s\n",argv[optind]);
else
yyin=file_input;
}	

(error_flag=yyparse()) ? printf("\a\n\n"):printf("Ok !\n\n");

if (list_flag && ! error_flag) 
 for (i=0;i<nextquad;i++)
	print_quad(i);

if (run_flag && ! error_flag) 
 	hal9000();

return 0;
}

