#ifndef TIPI_H
#define TIPI_H

#define MAX_ID_LEN		20
#define MAX_SYM			100
#define MAX_ISTR		1500
#define NOLEVEL 		-1
#define VERO			1
#define FALSO			0

#define PROC_HEADER		4

typedef struct nodolista *lista;

struct nodolista
  {
    int elem;
    lista next;
  } ;

typedef struct coda
  {
    lista testa;
    lista coda;
  }
 coda;

typedef enum istr_opc
  {
    HALT,GOTO,CALL,RETURN,ALLOC,
    READI,WRITEI,IASSIGN,ITOR,MOD,
    IADD,ISUB,IMUL,IDIV,IGTR,IGEQ,ILSS,ILEQ,IEQ,INEQ,IUMIN,IPARAM,
    RADD,RSUB,RMUL,RDIV,RGTR,RGEQ,RLSS,RLEQ,REQ,RNEQ,RUMIN,RPARAM,
    READR,WRITER,RASSIGN
      }
istr_opcode;

typedef union tipi_numero
  {
    double 	reale;    /*  si assume che il double abbia la mantissa almeno quanto in int */
    int 	intero;

  }
num_type;			/* tipo di num e dell' operando immediato */

typedef struct op_ind
  {
    int level;			/* tipo dell' operando indiretto */
    int offset;
  }
op_indir;

typedef struct op_f
  {
    num_type imm;		/* tipo dell' operando */
    op_indir ind;
  }
operandi;

typedef struct quad
  {
    istr_opcode opcode;
    operandi op1, op2, op3;
  }
quadrupla;

typedef struct list_param_typed
  {
    coda  lista_parametri;
    int   numero_parametri;
    int   tipo; 	
  } parametri_attrib;

typedef struct attributi_expresione
  {
    coda truelist;
    coda falselist;
  }
expressione_attrib;

typedef struct attributi_s_expr
  {
    int type;
    operandi place;
  }
s_expr_attrib;


typedef struct attributi_num
  {
    int type;
    num_type val;
  }
num_attrib;

typedef struct s_l
  {
    char 	*name;
    int 	type;
    num_type 	val;
    op_indir 	ind;
    lista    	param_list;
    int 	numero_parametri;	
    int 	prima_quad;
    int		size;					
  }
sym_elem;			/* elemento di symbol table */

typedef struct symbol_tbl
  {
    sym_elem symbol[MAX_SYM];
    int next_free_sym;
  }
 *p_symbol_tbl;

/* Prototipi */


int insert (p_symbol_tbl S, sym_elem el);
int defined(p_symbol_tbl S,sym_elem el);
int find (p_symbol_tbl S, char *c);

coda merge (coda  p1, coda  p2);
coda makelist (int d);
void backpatch (coda p, int i);

void print_quad(int quad);
void hal9000();		

int yyerror(char *s); 
#endif

/* occorre almeno una #define ALLOCA tra i files.c  per condividere tra piu files alcune variabili globali*/
#ifdef  ALLOCA		
#define STORAGE
#define INITIALIZE(x) x
#else   
#define STORAGE extern
#define INITIALIZE(x)
#endif	

STORAGE int run_flag		INITIALIZE(=0);
STORAGE int error_flag	 	INITIALIZE(=0);
STORAGE int list_flag    	INITIALIZE(=0);
STORAGE int verbose_flag 	INITIALIZE(=0);

STORAGE int max_stack 		INITIALIZE(=1000);
STORAGE int numerolinea 	INITIALIZE(=1);
STORAGE int yydebug     	INITIALIZE(=0);  
STORAGE int trace_flag  	INITIALIZE(=0);  
STORAGE FILE *file_output  	INITIALIZE(=stdout); 
STORAGE FILE *file_input   	INITIALIZE(=stdin);
STORAGE FILE *file_errori  	INITIALIZE(=stderr);

STORAGE quadrupla quadvect[MAX_ISTR];

#undef STORAGE 
#undef INITIALIZE




